# -*- ruby encoding: utf-8 -*-
#############################################################
# This file was automatically generated on 2017-04-21.      #
#                                                           #
# Ruby Bindings Version 2.1.12                              #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################

module Tinkerforge
  # Measures distance up to 40m with laser light
  class BrickletLaserRangeFinder < Device
    DEVICE_IDENTIFIER = 255 # :nodoc:
    DEVICE_DISPLAY_NAME = 'Laser Range Finder Bricklet' # :nodoc:

    # This callback is triggered periodically with the period that is set by
    # BrickletLaserRangeFinder#set_distance_callback_period. The parameter is the distance
    # value of the sensor.
    # 
    # The CALLBACK_DISTANCE callback is only triggered if the distance value has changed
    # since the last triggering.
    CALLBACK_DISTANCE = 20

    # This callback is triggered periodically with the period that is set by
    # BrickletLaserRangeFinder#set_velocity_callback_period. The parameter is the velocity
    # value of the sensor.
    # 
    # The CALLBACK_VELOCITY callback is only triggered if the velocity has changed since
    # the last triggering.
    CALLBACK_VELOCITY = 21

    # This callback is triggered when the threshold as set by
    # BrickletLaserRangeFinder#set_distance_callback_threshold is reached.
    # The parameter is the distance value of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletLaserRangeFinder#set_debounce_period.
    CALLBACK_DISTANCE_REACHED = 22

    # This callback is triggered when the threshold as set by
    # BrickletLaserRangeFinder#set_velocity_callback_threshold is reached.
    # The parameter is the velocity value of the sensor.
    # 
    # If the threshold keeps being reached, the callback is triggered periodically
    # with the period as set by BrickletLaserRangeFinder#set_debounce_period.
    CALLBACK_VELOCITY_REACHED = 23

    FUNCTION_GET_DISTANCE = 1 # :nodoc:
    FUNCTION_GET_VELOCITY = 2 # :nodoc:
    FUNCTION_SET_DISTANCE_CALLBACK_PERIOD = 3 # :nodoc:
    FUNCTION_GET_DISTANCE_CALLBACK_PERIOD = 4 # :nodoc:
    FUNCTION_SET_VELOCITY_CALLBACK_PERIOD = 5 # :nodoc:
    FUNCTION_GET_VELOCITY_CALLBACK_PERIOD = 6 # :nodoc:
    FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD = 7 # :nodoc:
    FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD = 8 # :nodoc:
    FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD = 9 # :nodoc:
    FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD = 10 # :nodoc:
    FUNCTION_SET_DEBOUNCE_PERIOD = 11 # :nodoc:
    FUNCTION_GET_DEBOUNCE_PERIOD = 12 # :nodoc:
    FUNCTION_SET_MOVING_AVERAGE = 13 # :nodoc:
    FUNCTION_GET_MOVING_AVERAGE = 14 # :nodoc:
    FUNCTION_SET_MODE = 15 # :nodoc:
    FUNCTION_GET_MODE = 16 # :nodoc:
    FUNCTION_ENABLE_LASER = 17 # :nodoc:
    FUNCTION_DISABLE_LASER = 18 # :nodoc:
    FUNCTION_IS_LASER_ENABLED = 19 # :nodoc:
    FUNCTION_GET_SENSOR_HARDWARE_VERSION = 24 # :nodoc:
    FUNCTION_SET_CONFIGURATION = 25 # :nodoc:
    FUNCTION_GET_CONFIGURATION = 26 # :nodoc:
    FUNCTION_GET_IDENTITY = 255 # :nodoc:

    THRESHOLD_OPTION_OFF = 'x' # :nodoc:
    THRESHOLD_OPTION_OUTSIDE = 'o' # :nodoc:
    THRESHOLD_OPTION_INSIDE = 'i' # :nodoc:
    THRESHOLD_OPTION_SMALLER = '<' # :nodoc:
    THRESHOLD_OPTION_GREATER = '>' # :nodoc:
    MODE_DISTANCE = 0 # :nodoc:
    MODE_VELOCITY_MAX_13MS = 1 # :nodoc:
    MODE_VELOCITY_MAX_32MS = 2 # :nodoc:
    MODE_VELOCITY_MAX_64MS = 3 # :nodoc:
    MODE_VELOCITY_MAX_127MS = 4 # :nodoc:
    VERSION_1 = 1 # :nodoc:
    VERSION_3 = 3 # :nodoc:

    # Creates an object with the unique device ID <tt>uid</tt> and adds it to
    # the IP Connection <tt>ipcon</tt>.
    def initialize(uid, ipcon)
      super uid, ipcon

      @api_version = [2, 0, 1]

      @response_expected[FUNCTION_GET_DISTANCE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DISTANCE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DISTANCE_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VELOCITY_CALLBACK_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VELOCITY_CALLBACK_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_TRUE
      @response_expected[FUNCTION_GET_DEBOUNCE_PERIOD] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MOVING_AVERAGE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MOVING_AVERAGE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_MODE] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_MODE] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_ENABLE_LASER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_DISABLE_LASER] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_IS_LASER_ENABLED] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[CALLBACK_DISTANCE] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_VELOCITY] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_DISTANCE_REACHED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[CALLBACK_VELOCITY_REACHED] = RESPONSE_EXPECTED_ALWAYS_FALSE
      @response_expected[FUNCTION_GET_SENSOR_HARDWARE_VERSION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_SET_CONFIGURATION] = RESPONSE_EXPECTED_FALSE
      @response_expected[FUNCTION_GET_CONFIGURATION] = RESPONSE_EXPECTED_ALWAYS_TRUE
      @response_expected[FUNCTION_GET_IDENTITY] = RESPONSE_EXPECTED_ALWAYS_TRUE

      @callback_formats[CALLBACK_DISTANCE] = 'S'
      @callback_formats[CALLBACK_VELOCITY] = 's'
      @callback_formats[CALLBACK_DISTANCE_REACHED] = 'S'
      @callback_formats[CALLBACK_VELOCITY_REACHED] = 's'
    end

    # Returns the measured distance. The value has a range of 0 to 4000
    # and is given in cm.
    # 
    # Sensor hardware version 1 (see BrickletLaserRangeFinder#get_sensor_hardware_version) cannot
    # measure distance and velocity at the same time. Therefore, the distance mode
    # has to be enabled using BrickletLaserRangeFinder#set_mode.
    # Sensor hardware version 3 can measure distance and velocity at the same
    # time. Also the laser has to be enabled, see BrickletLaserRangeFinder#enable_laser.
    # 
    # If you want to get the distance periodically, it is recommended to
    # use the CALLBACK_DISTANCE callback and set the period with
    # BrickletLaserRangeFinder#set_distance_callback_period.
    def get_distance
      send_request(FUNCTION_GET_DISTANCE, [], '', 2, 'S')
    end

    # Returns the measured velocity. The value has a range of -12800 to 12700
    # and is given in 1/100 m/s.
    # 
    # Sensor hardware version 1 (see BrickletLaserRangeFinder#get_sensor_hardware_version) cannot
    # measure distance and velocity at the same time. Therefore, the velocity mode
    # has to be enabled using BrickletLaserRangeFinder#set_mode.
    # Sensor hardware version 3 can measure distance and velocity at the same
    # time, but the velocity measurement only produces stables results if a fixed
    # measurement rate (see BrickletLaserRangeFinder#set_configuration) is configured. Also the laser
    # has to be enabled, see BrickletLaserRangeFinder#enable_laser.
    # 
    # If you want to get the velocity periodically, it is recommended to
    # use the CALLBACK_VELOCITY callback and set the period with
    # BrickletLaserRangeFinder#set_velocity_callback_period.
    def get_velocity
      send_request(FUNCTION_GET_VELOCITY, [], '', 2, 's')
    end

    # Sets the period in ms with which the CALLBACK_DISTANCE callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_DISTANCE callback is only triggered if the distance value has
    # changed since the last triggering.
    # 
    # The default value is 0.
    def set_distance_callback_period(period)
      send_request(FUNCTION_SET_DISTANCE_CALLBACK_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickletLaserRangeFinder#set_distance_callback_period.
    def get_distance_callback_period
      send_request(FUNCTION_GET_DISTANCE_CALLBACK_PERIOD, [], '', 4, 'L')
    end

    # Sets the period in ms with which the CALLBACK_VELOCITY callback is triggered
    # periodically. A value of 0 turns the callback off.
    # 
    # The CALLBACK_VELOCITY callback is only triggered if the velocity value has
    # changed since the last triggering.
    # 
    # The default value is 0.
    def set_velocity_callback_period(period)
      send_request(FUNCTION_SET_VELOCITY_CALLBACK_PERIOD, [period], 'L', 0, '')
    end

    # Returns the period as set by BrickletLaserRangeFinder#set_velocity_callback_period.
    def get_velocity_callback_period
      send_request(FUNCTION_GET_VELOCITY_CALLBACK_PERIOD, [], '', 4, 'L')
    end

    # Sets the thresholds for the CALLBACK_DISTANCE_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the distance value is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the distance value is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the distance value is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the distance value is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_distance_callback_threshold(option, min, max)
      send_request(FUNCTION_SET_DISTANCE_CALLBACK_THRESHOLD, [option, min, max], 'k S S', 0, '')
    end

    # Returns the threshold as set by BrickletLaserRangeFinder#set_distance_callback_threshold.
    def get_distance_callback_threshold
      send_request(FUNCTION_GET_DISTANCE_CALLBACK_THRESHOLD, [], '', 5, 'k S S')
    end

    # Sets the thresholds for the CALLBACK_VELOCITY_REACHED callback.
    # 
    # The following options are possible:
    # 
    #  "Option", "Description"
    # 
    #  "'x'",    "Callback is turned off"
    #  "'o'",    "Callback is triggered when the velocity is *outside* the min and max values"
    #  "'i'",    "Callback is triggered when the velocity is *inside* the min and max values"
    #  "'<'",    "Callback is triggered when the velocity is smaller than the min value (max is ignored)"
    #  "'>'",    "Callback is triggered when the velocity is greater than the min value (max is ignored)"
    # 
    # The default value is ('x', 0, 0).
    def set_velocity_callback_threshold(option, min, max)
      send_request(FUNCTION_SET_VELOCITY_CALLBACK_THRESHOLD, [option, min, max], 'k s s', 0, '')
    end

    # Returns the threshold as set by BrickletLaserRangeFinder#set_velocity_callback_threshold.
    def get_velocity_callback_threshold
      send_request(FUNCTION_GET_VELOCITY_CALLBACK_THRESHOLD, [], '', 5, 'k s s')
    end

    # Sets the period in ms with which the threshold callbacks
    # 
    # * CALLBACK_DISTANCE_REACHED,
    # * CALLBACK_VELOCITY_REACHED,
    # 
    # are triggered, if the thresholds
    # 
    # * BrickletLaserRangeFinder#set_distance_callback_threshold,
    # * BrickletLaserRangeFinder#set_velocity_callback_threshold,
    # 
    # keep being reached.
    # 
    # The default value is 100.
    def set_debounce_period(debounce)
      send_request(FUNCTION_SET_DEBOUNCE_PERIOD, [debounce], 'L', 0, '')
    end

    # Returns the debounce period as set by BrickletLaserRangeFinder#set_debounce_period.
    def get_debounce_period
      send_request(FUNCTION_GET_DEBOUNCE_PERIOD, [], '', 4, 'L')
    end

    # Sets the length of a `moving averaging <https://en.wikipedia.org/wiki/Moving_average>`__
    # for the distance and velocity.
    # 
    # Setting the length to 0 will turn the averaging completely off. With less
    # averaging, there is more noise on the data.
    # 
    # The range for the averaging is 0-30.
    # 
    # The default value is 10.
    def set_moving_average(distance_average_length, velocity_average_length)
      send_request(FUNCTION_SET_MOVING_AVERAGE, [distance_average_length, velocity_average_length], 'C C', 0, '')
    end

    # Returns the length moving average as set by BrickletLaserRangeFinder#set_moving_average.
    def get_moving_average
      send_request(FUNCTION_GET_MOVING_AVERAGE, [], '', 2, 'C C')
    end

    # .. note::
    #  This function is only available if you have a LIDAR-Lite sensor with hardware
    #  version 1. Use BrickletLaserRangeFinder#set_configuration for hardware version 3. You can check
    #  the sensor hardware version using BrickletLaserRangeFinder#get_sensor_hardware_version.
    # 
    # The LIDAR-Lite sensor (hardware version 1) has five different modes. One mode is
    # for distance measurements and four modes are for velocity measurements with
    # different ranges.
    # 
    # The following modes are available:
    # 
    # * 0: Distance is measured with resolution 1.0 cm and range 0-400 cm
    # * 1: Velocity is measured with resolution 0.1 m/s and range is 0-12.7 m/s
    # * 2: Velocity is measured with resolution 0.25 m/s and range is 0-31.75 m/s
    # * 3: Velocity is measured with resolution 0.5 m/s and range is 0-63.5 m/s
    # * 4: Velocity is measured with resolution 1.0 m/s and range is 0-127 m/s
    # 
    # The default mode is 0 (distance is measured).
    def set_mode(mode)
      send_request(FUNCTION_SET_MODE, [mode], 'C', 0, '')
    end

    # Returns the mode as set by BrickletLaserRangeFinder#set_mode.
    def get_mode
      send_request(FUNCTION_GET_MODE, [], '', 1, 'C')
    end

    # Activates the laser of the LIDAR.
    # 
    # We recommend that you wait 250ms after enabling the laser before
    # the first call of BrickletLaserRangeFinder#get_distance to ensure stable measurements.
    def enable_laser
      send_request(FUNCTION_ENABLE_LASER, [], '', 0, '')
    end

    # Deactivates the laser of the LIDAR.
    def disable_laser
      send_request(FUNCTION_DISABLE_LASER, [], '', 0, '')
    end

    # Returns *true* if the laser is enabled, *false* otherwise.
    def is_laser_enabled
      send_request(FUNCTION_IS_LASER_ENABLED, [], '', 1, '?')
    end

    # Returns the LIDAR-Lite hardware version.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def get_sensor_hardware_version
      send_request(FUNCTION_GET_SENSOR_HARDWARE_VERSION, [], '', 1, 'C')
    end

    # .. note::
    #  This function is only available if you have a LIDAR-Lite sensor with hardware
    #  version 3. Use BrickletLaserRangeFinder#set_mode for hardware version 1. You can check
    #  the sensor hardware version using BrickletLaserRangeFinder#get_sensor_hardware_version.
    # 
    # The **Aquisition Count** defines the number of times the Laser Range Finder Bricklet
    # will integrate acquisitions to find a correlation record peak. With a higher count,
    # the Bricklet can measure longer distances. With a lower count, the rate increases. The
    # allowed values are 1-255.
    # 
    # If you set **Enable Quick Termination** to true, the distance measurement will be terminated
    # early if a high peak was already detected. This means that a higher measurement rate can be achieved
    # and long distances can be measured at the same time. However, the chance of false-positive
    # distance measurements increases.
    # 
    # Normally the distance is calculated with a detection algorithm that uses peak value,
    # signal strength and noise. You can however also define a fixed **Threshold Value**.
    # Set this to a low value if you want to measure the distance to something that has
    # very little reflection (e.g. glass) and set it to a high value if you want to measure
    # the distance to something with a very high reflection (e.g. mirror). Set this to 0 to
    # use the default algorithm. The other allowed values are 1-255.
    # 
    # Set the **Measurement Frequency** in Hz to force a fixed measurement rate. If set to 0,
    # the Laser Range Finder Bricklet will use the optimal frequency according to the other
    # configurations and the actual measured distance. Since the rate is not fixed in this case,
    # the velocity measurement is not stable. For a stable velocity measurement you should
    # set a fixed measurement frequency. The lower the frequency, the higher is the resolution
    # of the calculated velocity. The allowed values are 10Hz-500Hz (and 0 to turn the fixed
    # frequency off).
    # 
    # The default values for Acquisition Count, Enable Quick Termination, Threshold Value and
    # Measurement Frequency are 128, false, 0 and 0.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def set_configuration(acquisition_count, enable_quick_termination, threshold_value, measurement_frequency)
      send_request(FUNCTION_SET_CONFIGURATION, [acquisition_count, enable_quick_termination, threshold_value, measurement_frequency], 'C ? C S', 0, '')
    end

    # Returns the configuration as set by BrickletLaserRangeFinder#set_configuration.
    # 
    # .. versionadded:: 2.0.3$nbsp;(Plugin)
    def get_configuration
      send_request(FUNCTION_GET_CONFIGURATION, [], '', 5, 'C ? C S')
    end

    # Returns the UID, the UID where the Bricklet is connected to,
    # the position, the hardware and firmware version as well as the
    # device identifier.
    # 
    # The position can be 'a', 'b', 'c' or 'd'.
    # 
    # The device identifier numbers can be found :ref:`here <device_identifier>`.
    # |device_identifier_constant|
    def get_identity
      send_request(FUNCTION_GET_IDENTITY, [], '', 25, 'Z8 Z8 k C3 C3 S')
    end

    # Registers a callback with ID <tt>id</tt> to the block <tt>block</tt>.
    def register_callback(id, &block)
      callback = block
      @registered_callbacks[id] = callback
    end
  end
end
